// ltr27example.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "conio.h"
#include "ltr\include\ltr27api.h"
#include <algorithm>


#define SNUMBER  (32)
int oem_printf(const char *s, ...)
{
	char str[1024];
	va_list list;
	va_start(list, s);
	vsprintf(str, s, list);
	va_end(list);
	CharToOem((LPCWSTR)str, str);
	return printf(str);
}

int _tmain(int argc, _TCHAR* argv[])
{
	INT res;
	TLTR27 ltr27;
	
	//      
	res=LTR27_Init(&ltr27);
	if(res==LTR_OK) {
		oem_printf(">> LTR27_Init()                 -> ok\n");
		//         .
		//   ,   ltr-   
		//     
		res=LTR27_Open(&ltr27, SADDR_DEFAULT, SPORT_DEFAULT, "", CC_MODULE1);
		if (res==LTR_WARNING_MODULE_IN_USE)
		{
			oem_printf(">> Warning, module Already Opened         \n");
			res=LTR_OK;
		}
		if(res==LTR_OK) 
		{
			oem_printf(">> LTR27_Open()                 -> ok\n");
			//   :
			//        		

			res=LTR27_GetConfig(&ltr27);
			if(res==LTR_OK) 
			{
				oem_printf(">> LTR27_GetConfig()            -> ok\n");
				//     				
				res=LTR27_GetDescription(&ltr27, LTR27_MODULE_DESCRIPTION);
				for(int i=0; i<LTR27_MEZZANINE_NUMBER && res==LTR_OK; i++)
				{
					if(strcmp(ltr27.Mezzanine[i].Name, "EMPTY")) 
					{
						res=LTR27_GetDescription(&ltr27, LTR27_MEZZANINE1_DESCRIPTION<<i);
						oem_printf((char *)ltr27.ModuleInfo.Mezzanine[i].Name);
						oem_printf("\n");
					}					
				}			

				if(res==LTR_OK) 
				{
					oem_printf(">> LTR27_GetModuleDescription() -> ok\n");
					oem_printf(">> Module description :\n");
					oem_printf(">> CompanyName  : %s\n", ltr27.ModuleInfo.Module.CompanyName);
					oem_printf(">> DeviceName   : %s\n", ltr27.ModuleInfo.Module.DeviceName);
					oem_printf(">> SerialNumber : %s\n", ltr27.ModuleInfo.Module.SerialNumber);
					if(ltr27.ModuleInfo.Cpu.Active) 
					{
						oem_printf(">> CPU description :\n");
						oem_printf(">> Name      : %s\n",    ltr27.ModuleInfo.Cpu.Name);
						oem_printf(">> ClockRate : %.1f Hz\n", ltr27.ModuleInfo.Cpu.ClockRate);
						oem_printf(">> Firmware  : %08X\n",  ltr27.ModuleInfo.Cpu.FirmwareVersion);
						oem_printf(">> Comment   : %s\n",    ltr27.ModuleInfo.Cpu.Comment);
					} else oem_printf(">> CPU description not present\n");

					for(int i=0; i<LTR27_MEZZANINE_NUMBER; i++) 
					{
						if(ltr27.ModuleInfo.Mezzanine[i].Active) 
						{
							oem_printf(">> Mezzanine%d description :\n", i+1);
							oem_printf(">> Name          : %s\n", ltr27.ModuleInfo.Mezzanine[i].Name);
							oem_printf(">> SerialNumber  : %s\n", ltr27.ModuleInfo.Mezzanine[i].SerialNumber);
							oem_printf(">> Revision      : %d\n", (int)ltr27.ModuleInfo.Mezzanine[i].Revision);
							for(int j=0; j<4; j++)
							{
								oem_printf(">> Calibration%d  : %.3f\n", j, ltr27.ModuleInfo.Mezzanine[i].Calibration[j]);
							}
						}
					}
					//    1000
					ltr27.FrequencyDivisor=0;
					//   
					for(int i=0; i<LTR27_MEZZANINE_NUMBER; i++)
						for(int j=0; j<4; j++)
							ltr27.Mezzanine[i].CalibrCoeff[j]=ltr27.ModuleInfo.Mezzanine[i].Calibration[j];
					//      
					res=LTR27_SetConfig(&ltr27);
					if(res==LTR_OK) {
						//    
						res=LTR27_ADCStart(&ltr27);
						if(res==LTR_OK) 
						{
							DWORD buf[SNUMBER][2*LTR27_MEZZANINE_NUMBER];
							DWORD Tend=GetTickCount()+10000;

							while(GetTickCount()<Tend)
							{
								//   
								INT size=LTR27_Recv(&ltr27, buf[0], NULL, 2*LTR27_MEZZANINE_NUMBER*SNUMBER, 10000);
								if(size>0) 
								{
									double data[SNUMBER][2*LTR27_MEZZANINE_NUMBER];;
									DWORD data_size=size;
									//  ,   
									res=LTR27_ProcessData(&ltr27, buf[0], data[0], &data_size, 1, 1);
									if(res==LTR_OK) 
									{
										//  
										for(int i=0; i<SNUMBER; i++) 
										{
											for(int j=0; j<2*LTR27_MEZZANINE_NUMBER; j++)
												if(strcmp(ltr27.Mezzanine[j>>1].Name, "EMPTY")) oem_printf("  %.4f%s", data[i][j], ltr27.Mezzanine[j>>1].Unit);
											oem_printf("\n");
										}
									}
								}
								Sleep(1000);
							}
							//  
							res=LTR27_ADCStop(&ltr27);
						}
					}
				}
			}
			//  
			LTR27_Close(&ltr27);
		}
	}

	//    
	if(res!=LTR_OK) oem_printf(">> %s\n", LTR27_GetErrorString(res));
	//
	oem_printf("press any key...\n");
	while(!kbhit());
	return 0;
}

